/*
* pov.h
*
* $Id: pov.h,v 1.4 2003/02/18 23:23:53 Paul Exp $
*
* Copyright (C) 1998-2003 by Paul Thiessen, Chemical Graphics
*                 paul@chemicalgraphics.com
*           http://www.chemicalgraphics.com/paul
*
* Header for the main POV output module.
*/

#ifndef __vrml2pov_pov_h_
#define __vrml2pov_pov_h_

#include "parser.h"
#include "matrix.h"

void do_POV_output(ParserObject*, const char*, const char*);
void do_node(SFNode*);

class View_transform {
public:
	Matrix m;
	F_TYPE angle;
	char* description;
    View_transform() { description=NULL; }
    ~View_transform() { if (description) delete description; }
};

// "global" variables in pov.cc
#ifndef __vrml2pov_pov_cc_
extern int verbose;
extern std::ofstream out;
extern DLList<View_transform> view_transform_stack;
extern double headlight, line_radius, point_radius;
extern int do_backface_culling;
extern F_TYPE *culling_viewpoint;
#endif

nodeVariable* find_field(SFNode* node, const char* id);
#define FIND(NODE,FIELD,TYPE) ((TYPE*)(find_field(NODE,#FIELD)->fieldValue))

#define MEMOUT do { cerr << "Ran out of memory\n"; abort(); } while (0)

#define FINISH_SIZE 1024

#endif // __vrml2pov_pov_h_
