/*
* stdnodes.h
*
* $Id: stdnodes.h,v 1.3 2003/02/18 23:23:54 Paul Exp $
*
* Copyright (C) 1998-2003 by Paul Thiessen, Chemical Graphics
*                 paul@chemicalgraphics.com
*           http://www.chemicalgraphics.com/paul
*
* This file contains functions that are used to define standard nodes.
*/

#ifndef __vrml2pov_stdnodes_h_
#define __vrml2pov_stdnodes_h_

int find_standard_node(const char*);

#define IMPLEMENTED 1
#define UNIMPLEMENTED (-2)

#ifndef __vrml2pov_stdnodes_cc_
extern int (*finish_function)(SFNode*);
inline int finish_node(SFNode* n)
{
	int status;
	if ((status=find_standard_node(n->nodeTypeId))==IMPLEMENTED)
		return (*finish_function)(n);
	else if (status==UNIMPLEMENTED)
		return 1;
	else
		return 0;
}
extern int (*type_function)(const char*);
inline int node_field_type(const char* nodeTypeId, const char* fieldId)
{
	if (find_standard_node(nodeTypeId))
		return (*type_function)(fieldId);
	else
		return 0;
}
#endif

#endif // __vrml2pov_stdnodes_h_
